# Contributing to Mockingbird

## Getting Started

Welcome! We’re excited to have you as part of the Mockingbird developer community.

- [Join the #mockingbird Slack channel](https://join.slack.com/t/birdopensource/shared_invite/zt-wogxij50-3ZM7F8ZxFXvPkE0j8xTtmw)
- [Check out the GitHub tasks board](https://github.com/birdrides/mockingbird/projects/2)
- [Search for good first issues](https://github.com/birdrides/mockingbird/issues?q=is%3Aopen+is%3Aissue+label%3A%22good+first+issue%22)

## Issues and Bugs

Before opening an issue, please search the [existing GitHub issues](https://github.com/birdrides/mockingbird/issues) and list of [common problems](https://mockingbirdswift.com/common-problems). Use one of the provided issue templates so that others have sufficient context to fix the issue.

## Feature Requests

Submit feature requests as a [GitHub issue](https://github.com/birdrides/mockingbird/issues/new/choose), using the provided “Feature Request” template.

## Pull Requests

Use the provided “Pull Request” template when submitting pull requests. If making a change to codegen or the testing runtime, make sure to update the end-to-end and/or framework tests.

All pull requests are squash-merged into `master`. For large or complex changes, consider creating a stacked pull request and joining the [#mockingbird Slack channel](https://join.slack.com/t/birdopensource/shared_invite/zt-wogxij50-3ZM7F8ZxFXvPkE0j8xTtmw) to facilitate discussion.

## Coding Guidelines

Mockingbird loosely follows [Google’s Swift style guide](https://google.github.io/swift/). When in doubt, prefer consistency with existing conventions in the code.
