# Feature Comparison Table

Compare Swift mocking frameworks by features.

## Overview

| **Legend** |  |  |
| --- | --- | --- |
| ✅ Full support | ✴️ Partial support | ❌ No support |

|  | Mockingbird | Cuckoo | SwiftyMocky | Mockolo |
| --- | --- | --- | --- | --- |
| Protocol Mocks | ✅ | ✅ | ✅ | ✅ |
| Class Mocks | ✅ | ✅ | ❌ | ✅ |
| Partial Class Mocks | ✅ | ✅ | ❌ | ❌ |
| Partial Protocol Mocks | ✅ | ❌ | ❌ | ❌ |
| Objective-C Mocks | ✅ | ✴️ | ❌ | ❌ |
| | | | |
| Protocol Inheritance | ✅ | ✅ | ✅ | ✅ |
| Class Inheritance | ✅ | ✅ | ❌ | ✅ |
| External Type Inheritance | ✅ | ❌ | ❌ | ✴️ |
| | | | |
| Mock Methods | ✅ | ✅ | ✅ | ✅ |
| Mock Properties | ✅ | ✅ | ✅ | ✅ |
| Mock Subscripts | ✅ | ❌ | ✅ | ✅ |
| Mock Static Methods | ✅ | ❌ | ✅ | ✅ |
| Mock Static Properties | ✅ | ❌ | ✅ | ✅ |
| Mock Async Methods | ✅ | ✅ | ✅ | ✅ |
| | | | |
| Stub Returning Value | ✅ | ✅ | ✅ | ✅ |
| Stub Throwing Errors | ✅ | ✅ | ✅ | ✅ |
| Stub Parameterized Methods | ✅ | ✅ | ✅ | ✅ |
| Stub Variadic Parameters | ✅ | ❌ | ❌ | ✅ |
| Stub Inout Parameters | ✅ | ❌ | ✅ | ✴️ |
| Stub Sequences | ✅ | ✅ | ✅ | ✴️ |
| | | | |
| Protocol Level Generics | ✅ | ✴️ | ✴️ | ✴️ |
| Class Level Generics | ✅ | ✴️ | ❌ | ✴️ |
| Function Level Generics | ✅ | ✅ | ✅ | ✴️ |
| Subscript Generics | ✅ | ❌ | ✅ | ✴️ |
| | | | |
| Nested Classes | ✅ | ❌ | ❌ | ❌ |
| Type Aliasing | ✅ | ✅ | ✅ | ✅ |
| Fully-Qualified Types | ✅ | ❌ | ❌ | ❌ |
| Compilation Conditions | ✅ | ❌ | ❌ | ❌ |
| | | | |
| Exact Argument Matching | ✅ | ✅ | ✅ | ✅ |
| Wildcard Argument Matching | ✅ | ✅ | ✅ | ✴️ |
| | | | |
| Relaxed Mocks | ✅ | ✴️ | ❌ | ✅ |
| In Order Verification | ✅ | ❌ | ❌ | ✴️ |
| Asynchronous Verification | ✅ | ❌ | ❌ | ✴️ |
| Thread-Safe Testing | ✅ | ❌ | ❌ | ❌ |
| Argument Capturing | ✅ | ✅ | ✅ | ✴️ |
| | | | |
| No Prod Code Changes | ✅ | ✅ | ❌ | ❌ |
| Xcode Integration | ✅ | ❌ | ❌ | ❌ |
| Source File Exclusion | ✅ | ✅ | ✅ | ✅ |
| Generated Output Caching | ✅ | ✅ | ❌ | ❌ |
